#!/bin/ksh

HOST=sas3par
CACTIDIR=/var/www/html/cacti/
TREENAME="3par-$HOST"
set -A HOSTNSP
set -A HOSTVOL
set -A HEADERS Ports Ports_IO_Size Ports_IOPS Ports_Service_Time Ports_Throughput Volumes
set -A HEADERDESC \\s+3par\\s+stats3parPorts+\\s$ \\s+3par\\s+stats3parPorts\\sIO\\sSize+\\s$ \\s+3par\\s+stats3parPorts\\sIOPS+\\s$ \\s+3par\\s+stats3parPorts\\sService\\sTime+\\s$ \\s+3par\\s+stats3parPorts\\sThroughput+\\s$ ""
set -A HEADERDESCSUM "Port Aggr Disk" "Port Aggr Host" "Utilization" "Interrupts" "Context Switches" "FreeSpace FC" "FreeSpace NL"
set -A HEADERIDS

cd $CACTIDIR/cli
print -n "adding tree $TREENAME :  "
php -q add_tree.php --type=tree --name="$TREENAME" --sort-method=manual
TREEID=`php -q add_tree.php --list-trees | grep "$TREENAME" | awk '{print $1}'`
HOSTID=`php -q add_tree.php --list-hosts | grep ${HOST}$ | awk '{print $1}'` 
php -q add_tree.php --list-graphs  --host-id=${HOSTID} | egrep \\s+3par\\s+stats3parPorts+\\s$ | awk '{print $4}' > /tmp/$$.$$

X=0
while read NSP
do
	HOSTNSP[X]=$NSP
	(( X = X + 1 ))	
done < /tmp/$$.$$
HOSTNSP[X]=""
php -q add_tree.php --list-graphs  --host-id=${HOSTID} | egrep \\s+3par\\s+stats3parVols+\\s$ | awk '{print $4}' > /tmp/$$.$$

X=0
while read VOL
do
	HOSTVOL[X]="$VOL"
	(( X = X + 1 ))
done < /tmp/$$.$$
rm /tmp/$$.$$

X=0
while [[ ${HEADERS[X]} != "" ]]
do
	print -n "adding header node ${HEADERS[X]} :   "
	php -q add_tree.php --type=node --node-type=header --tree-id=$TREEID --name=${HEADERS[X]}
	HEADERIDS[X]=`php -q add_tree.php --list-nodes --tree-id=$TREEID | grep ${HEADERS[X]} | awk '{print $2}'`
	(( X = X + 1 ))
done
php -q add_tree.php --type=node --node-type=header --tree-id=$TREEID --name=Summary
HEADERIDS[X]=`php -q add_tree.php --list-nodes --tree-id=$TREEID | grep Summary | awk '{print $2}'`

X=0
while [[ ${HEADERDESC[X]} != "" ]]
do
	Y=0
	while [[ ${HOSTNSP[Y]} != "" ]]
	do
		GRAPHID=`php -q add_tree.php --list-graphs --host-id=${HOSTID} | egrep "${HOSTNSP[Y]}(\s|\S)*${HEADERDESC[X]}" | awk '{print $1}'`
		print -n "adding graph ${HOST}'s ${HEADERDESC[X]} ${HOSTNSP[Y]} graph :   "
		php -q add_tree.php --type=node --node-type=graph --tree-id=$TREEID --parent-node=${HEADERIDS[X]} --graph-id=$GRAPHID
		(( Y = Y + 1 ))
	done
	(( X = X + 1 ))
done

Y=0
while [[ ${HOSTVOL[Y]} != "" ]]
do
	GRAPHID=`php -q add_tree.php --list-graphs --host-id=${HOSTID} | egrep "${HOSTVOL[Y]}\\s+3par\\s+stats3parVols+\\s$" | awk '{print $1}'`
	print -n "adding graph ${HOST}'s volume ${HOSTVOL[Y]} graph :   "
	php -q add_tree.php --type=node --node-type=graph --tree-id=$TREEID --parent-node=${HEADERIDS[X]} --graph-id=$GRAPHID
	(( Y = Y + 1 ))
done

(( X = X + 1 ))
Y=0
while [[ ${HEADERDESCSUM[Y]} != "" ]]
do
	GRAPHID=`php -q add_tree.php --list-graphs --host-id=${HOSTID} | egrep "${HEADERDESCSUM[Y]}" | awk '{print $1}'`
	print -n "adding graph ${HOST}'s ${HEADERDESCSUM[Y]} graph :   "
	php -q add_tree.php --type=node --node-type=graph --tree-id=$TREEID --parent-node=${HEADERIDS[X]} --graph-id=$GRAPHID
	(( Y = Y + 1 ))
done
